var global = this;

if (typeof global.jsCode == 'undefined')
{
    global.jsCode = {};
}

(function( global, doc )
{
    var jsCode = function( params )
    {
        return new jsCode.init( params );
    };
    
    jsCode.init = function( params )
    {
        return this;  
    };
    
    jsCode.init.prototype = 
    {
        constructor: jsCode,
        
        getPrototypeObject : function( object )
        {
            if ( typeof Object.getPrototypeOf !== 'function' )
            {
                if ( typeof object.__proto__ != 'undefined' )
                {
                    return object.__proto__;
                }
                else
                {
                    // May break if the constructor has been tampered with
                    return object.constructor.prototype;
                }
            }
            else
            {
                return Object.getPrototypeOf( object );
            }
        },
        
        test : function()
        {
            console.log('Function test complete');
            return this;
        },
       
        addMethod : function (name, fn)
        {
            var object = this.getPrototypeObject( this );
            
            // Save a reference to the old method 
            var old = object[ name ]; 
            
            // Overwrite the method with our new one 
            object[ name ] = function()
            {
                // Check the number of incoming arguments, 
                // compared to our overloaded function 
                if ( fn.length == arguments.length )
                {
                    // If there was a match, run the function 
                    return fn.apply( this, arguments ); 
                }
                // Otherwise, fallback to the old method 
                else if ( typeof old === "function" )
                {
                    return old.apply( this, arguments );
                } 
            }; 
        }
        
    };
    
    // Expose jsCode to the global object
    global.jsCode = jsCode;
    
})( global, document );

var test2 = function()
{
    console.log('Function test2 complete');
    return this;
};

jsCode().addMethod('test2', test2);

jsCode().test2().test();
